com.smartgwt.client.widgets

## Class Window

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.Window

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasCloseClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMaximizeClickHandlers, HasMinimizeClickHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRestoreClickHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers
  Direct Known Subclasses:
    ColorPicker, DateRangeDialog, Dialog, EventWindow, FieldPickerWindow, MultiGroupDialog, Portlet, PrintWindow

      public class Window
      extends VLayout
      implements HasCloseClickHandlers, HasMaximizeClickHandlers, HasMinimizeClickHandlers, HasRestoreClickHandlers

  A general purpose Window class for implementing dialogs, portlets, alerts, prompts, wizards and desktop-like windowing interfaces.

  Windows can contain arbitrary Smart GWT components, configured via the `items` property. Windows may be `modal` or non-modal.

  Windows provide a series of highly configurable and skinnable autoChildren including a header, various header controls, footer, and corner resizer.

  The more specialized `Dialog` subclass of Window has additional functionality targetted at simple prompts and confirmations, such as buttons with default actions, and single-method `shortcuts` for common application dialogs.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, isElementSet, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Window()`
    `Window(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.event.shared.HandlerRegistration` | `addCloseClickHandler(CloseClickHandler handler)` Add a closeClick handler.
    `void` | `addItem(Canvas component)` Adds a widget to the window.
    `void` | `addItem(com.google.gwt.user.client.ui.Widget widget)` Adds a widget to the window.
    `com.google.gwt.event.shared.HandlerRegistration` | `addMaximizeClickHandler(MaximizeClickHandler handler)` Add a maximizeClick handler.
    `void` | `addMember(Canvas newMember)` Same as `Layout.addMember`.
    `void` | `addMember(Canvas newMember, java.lang.Integer position)` Same as `Layout.addMember`.
    `com.google.gwt.event.shared.HandlerRegistration` | `addMinimizeClickHandler(MinimizeClickHandler handler)` Add a minimizeClick handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addRestoreClickHandler(RestoreClickHandler handler)` Add a restoreClick handler.
    `void` | `centerInPage()` Centers the Window in the page.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `void` | `close()` Close this window.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `void` | `flash()` Makes the window header flash if it's visible; if there's no header, or the header is hidden, makes the window body flash instead.
    `java.lang.Boolean` | `getAnimateMinimize()` Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?
    `java.lang.Boolean` | `getAutoCenter()` If true, this Window widget will automatically be centered on the page when shown.
    `java.lang.Boolean` | `getAutoSize()` If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
    `Canvas` | `getBody()` Body of the Window, where `contained components` or `loaded content` is shown.
    `java.lang.String` | `getBodyColor()` Color of the Window body.
    `java.lang.String` | `getBodyStyle()` Style of the Window body.
    `java.lang.Boolean` | `getCanDragReposition()` If true, this Window may be moved around by the user by dragging on the Window header.
    `java.lang.Boolean` | `getCanDragResize()` Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
    `java.lang.Boolean` | `getCanFocusInHeaderButtons()` If true, the user can give the header buttons keyboard focus (by clicking on them and including them in the tabOrder)
    `ImgButton` | `getCloseButton()` Button show in the header that will close this Window by calling `Window.closeClick`.
    `java.lang.String` | `getContentLayout()` The layout policy that should be used for widgets within the Window body.
    `java.lang.String` | `getContentsType()` If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.
    `int` | `getDefaultMinimizeHeight()` If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
    `java.lang.Boolean` | `getDismissOnEscape()` Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key? Behavior will only occur while the window or one of its descendants has focus, and does not cancel the Escape keypress.
    `java.lang.Boolean` | `getDismissOnOutsideClick()` If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button. Note: Applies only to modal windows.
    `HLayout` | `getFooter()` Optional footer for the window, providing space for controls such as the resizer and status bar.
    `int` | `getFooterHeight()` The height of the footer, in pixels.
    `HLayout` | `getHeader()` Header for the Window, based on an HLayout.
    `Img` | `getHeaderBackground()` Img background component for the header, for gradient or image-based display
    `Img` | `getHeaderIcon()` Header icon shown at left end of header by default.
    `Label` | `getHeaderLabel()` Label that shows Window title in header.
    `java.lang.String` | `getHeaderSrc()` If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.
    `java.lang.String` | `getHeaderStyle()` Style for the Window header.
    `java.lang.String` | `getHiliteBodyColor()` Highlight color for the Window body (shown when the body is flashed).
    `java.lang.String` | `getHiliteHeaderSrc()` If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`
    `java.lang.String` | `getHiliteHeaderStyle()` Highlight style for the Window header.
    `java.lang.Boolean` | `getIsModal()` If true, when shown this Window will intercept and block events to all other existing components on the page.
    `Canvas[]` | `getItems()` The contents of the Window body.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `ImgButton` | `getMaximizeButton()` Button that will make this Window fill the browser via `Window.maximize`.
    `java.lang.Boolean` | `getMaximized()` Is this window maximized.
    `AnimationAcceleration` | `getMinimizeAcceleration()` Default acceleration function for performing an animated minimize / maximize.
    `ImgButton` | `getMinimizeButton()` ImgButton shown in the header that will minimize this Window by calling `Window.minimize`.
    `java.lang.Boolean` | `getMinimized()` Is this window minimized.
    `java.lang.Integer` | `getMinimizeHeight()` Height for the window when minimized.
    `java.lang.Integer` | `getMinimizeTime()` If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.
    `Canvas` | `getModalMask()` A ScreenSpan instance used to darken the rest of a page when a modal window is active.
    `int` | `getModalMaskOpacity()` Controls the opacity of the modal mask displayed behind modal windows.
    `java.lang.String` | `getModalMaskStyle()` Specifies the CSS style for the modal mask.
    `java.lang.Integer` | `getOpacity()` Renders the widget to be partly transparent.
    `static Window` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `ImgButton` | `getResizer()` ImgButton-based resizer, shown in the footer.
    `ImgButton` | `getRestoreButton()` ImgButton that restores the Window via `Window.restore`.
    `java.lang.Boolean` | `getShowBody()` If true, draw the body contents when this Window is drawn.
    `java.lang.Boolean` | `getShowCloseButton()` If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick`.
    `java.lang.Boolean` | `getShowFooter()` If true, show a footer for this Window, including resizer, statusBar, etc.
    `java.lang.Boolean` | `getShowHeader()` If true, show a `header` for this Window.
    `java.lang.Boolean` | `getShowHeaderBackground()` Should the window header show a background image? Default value is true for all browsers except for Internet Explorer. If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.
    `java.lang.Boolean` | `getShowHeaderIcon()` If true, we show an icon on the left in the header.
    `java.lang.Boolean` | `getShowMaximizeButton()` If true, show a maximize button in the header - clicking it maximizes the Window
    `java.lang.Boolean` | `getShowMinimizeButton()` If true, show a minimize button in the header--clicking it minimizes the Window.
    `java.lang.Boolean` | `getShowModalMask()` If true, displays a translucent mask over the rest of the page when a modal window is displayed.
    `java.lang.Boolean` | `getShowResizer()` If true, show a button in the lower right corner that allows users to resize the Window.
    `java.lang.Boolean` | `getShowStatusBar()` If true, show a statusBar for this Window, including resizer.
    `java.lang.Boolean` | `getShowTitle()` Show a title (typically just text) on the header for this window.
    `java.lang.String` | `getSrc()` A URL to load as content for the Window's body.
    `java.lang.String` | `getStatus()` Text to show in the status bar of the window (if one is visible)
    `Canvas` | `getStatusBar()` Simple Canvas-based status bar, shown in the footer.
    `java.lang.String` | `getTitle()` title for this Window, shown in the header (if drawn)
    `java.lang.Boolean` | `getUseBackMask()` By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9.
    `void` | `maximize()` Maximize the window.
    `void` | `minimize()` Minimize the window.
    `java.lang.Boolean` | `onCloseClick()` Notification method fired when the user attempts to close the window via a click on the 'close' button, click outside the window if `dismissOnOutsideClick` is true, or on escape keypress if `dismissOnEscape` is true.
    `static void` | `preloadImages()` Preload primary window skin images
    `void` | `removeItem(Canvas component)` Removes a widget from the window.
    `void` | `restore()` Restores the window to its specified height and width after a call to `Window.minimize` or `Window.maximize`.
    `void` | `setAnimateMinimize(java.lang.Boolean animateMinimize)` Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?
    `void` | `setAutoCenter(java.lang.Boolean autoCenter)` If true, this Window widget will automatically be centered on the page when shown.
    `void` | `setAutoSize(java.lang.Boolean autoSize)` If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
    `void` | `setBodyColor(java.lang.String bodyColor)` Color of the Window body.
    `void` | `setBodyDefaults(java.util.Map bodyDefaults)` Default properties for the body of the Window
    `void` | `setBodyStyle(java.lang.String bodyStyle)` Style of the Window body.
    `void` | `setCanDragReposition(java.lang.Boolean canDragReposition)` If true, this Window may be moved around by the user by dragging on the Window header.
    `void` | `setCanDragResize(java.lang.Boolean canDragResize)` Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
    `void` | `setCanFocusInHeaderButtons(java.lang.Boolean canFocusInHeaderButtons)` If true, the user can give the header buttons keyboard focus (by clicking on them and including them in the tabOrder)
    `void` | `setContentLayout(java.lang.String contentLayout)` The layout policy that should be used for widgets within the Window body.
    `void` | `setContentsType(java.lang.String contentsType)` If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.
    `void` | `setDefaultMinimizeHeight(int defaultMinimizeHeight)` If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
    `static void` | `setDefaultProperties(Window windowProperties)` Class level method to set the default properties of this class.
    `void` | `setDismissOnEscape(java.lang.Boolean dismissOnEscape)` Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key? Behavior will only occur while the window or one of its descendants has focus, and does not cancel the Escape keypress.
    `void` | `setDismissOnOutsideClick(java.lang.Boolean dismissOnOutsideClick)` If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button. Note: Applies only to modal windows.
    `void` | `setFooterControls(java.lang.Object... footerControls)` Array of members to show in the Window footer.
    `void` | `setFooterHeight(int footerHeight)` The height of the footer, in pixels.
    `void` | `setHeaderControls(java.lang.Object... headerControls)` Array of members to show in the Window header.
    `void` | `setHeaderIcon(java.lang.String imgSrc)` Sets the Window header icon.
    `void` | `setHeaderIcon(java.lang.String imgSrc, int width, int height)` Sets the Window header icon.
    `void` | `setHeaderIconDefaults(java.util.Map headerIconDefaults)` This is an object literal property block specifying the various properties of the headerIcon - the icon that appears at the top left of the window and is by default the Isomorphic logo.
    `void` | `setHeaderIconProperties(java.util.Map headerIconProperties)`
    `void` | `setHeaderSrc(java.lang.String headerSrc)` If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.
    `void` | `setHeaderStyle(java.lang.String headerStyle)` Style for the Window header.
    `void` | `setHiliteBodyColor(java.lang.String hiliteBodyColor)` Highlight color for the Window body (shown when the body is flashed).
    `void` | `setHiliteHeaderSrc(java.lang.String hiliteHeaderSrc)` If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`
    `void` | `setHiliteHeaderStyle(java.lang.String hiliteHeaderStyle)` Highlight style for the Window header.
    `void` | `setIsModal(java.lang.Boolean isModal)` If true, when shown this Window will intercept and block events to all other existing components on the page.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setKeepInParentRect(java.lang.Boolean keepInParentRect)` If Window.canDragReposition or Window.canDragResize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)? Note: keepInParentRect affects only user drag interactions, not programmatic moves.
    `void` | `setKeepInParentRect(Rectangle rectangle)` If Window.canDragReposition or Window.canDragRShowcaseDataesize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)? Can also be set to an array denoting an arbitrary Rectangle beyond which the window cannot be moved.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.WindowLogicalStructure s)`
    `void` | `setMaximized(java.lang.Boolean maximized)` Is this window maximized.
    `void` | `setMinimizeAcceleration(AnimationAcceleration minimizeAcceleration)` Default acceleration function for performing an animated minimize / maximize.
    `void` | `setMinimized(java.lang.Boolean minimized)` Is this window minimized.
    `void` | `setMinimizeHeight(java.lang.Integer minimizeHeight)` Height for the window when minimized.
    `void` | `setMinimizeTime(java.lang.Integer minimizeTime)` If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.
    `void` | `setModalMaskOpacity(int modalMaskOpacity)` Controls the opacity of the modal mask displayed behind modal windows.
    `void` | `setModalMaskStyle(java.lang.String modalMaskStyle)` Specifies the CSS style for the modal mask.
    `void` | `setOpacity(java.lang.Integer opacity)` Renders the widget to be partly transparent.
    `void` | `setShowBody(java.lang.Boolean showBody)` If true, draw the body contents when this Window is drawn.
    `void` | `setShowCloseButton(java.lang.Boolean showCloseButton)` If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick`.
    `void` | `setShowFooter(java.lang.Boolean showFooter)` If true, show a footer for this Window, including resizer, statusBar, etc.
    `void` | `setShowHeader(java.lang.Boolean showHeader)` If true, show a `header` for this Window.
    `void` | `setShowHeaderBackground(java.lang.Boolean showHeaderBackground)` Should the window header show a background image? Default value is true for all browsers except for Internet Explorer. If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.
    `void` | `setShowHeaderIcon(java.lang.Boolean showHeaderIcon)` If true, we show an icon on the left in the header.
    `void` | `setShowMaximizeButton(java.lang.Boolean showMaximizeButton)` If true, show a maximize button in the header - clicking it maximizes the Window If this method is called after the component has been drawn/initialized: Dynamically update `showMaximizeButton` to show / hide the maximizeButton
    `void` | `setShowMinimizeButton(java.lang.Boolean showMinimizeButton)` If true, show a minimize button in the header--clicking it minimizes the Window.
    `void` | `setShowModalMask(java.lang.Boolean showModalMask)` If true, displays a translucent mask over the rest of the page when a modal window is displayed.
    `void` | `setShowResizer(java.lang.Boolean showResizer)` If true, show a button in the lower right corner that allows users to resize the Window.
    `void` | `setShowStatusBar(java.lang.Boolean showStatusBar)` If true, show a statusBar for this Window, including resizer.
    `void` | `setShowTitle(java.lang.Boolean showTitle)` Show a title (typically just text) on the header for this window.
    `void` | `setSrc(java.lang.String src)` A URL to load as content for the Window's body.
    `void` | `setStatus(java.lang.String status)` Text to show in the status bar of the window (if one is visible) If this method is called after the component has been drawn/initialized: Sets the text in the status bar of the window, redrawing if necessary.
    `void` | `setTitle(java.lang.String title)` title for this Window, shown in the header (if drawn) If this method is called after the component has been drawn/initialized: Sets the `title` that appears in the window `header`.
    `void` | `setUseBackMask(java.lang.Boolean useBackMask)` By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9.
    `java.lang.Boolean` | `shouldDismissOnEscape()` Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key? Default behavior: if `dismissOnEscape` is set, just return it.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOffset, getMemberOverlap, getMembers, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, membersChanged, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getSkinImgDir, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setCanvasItem, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlPosition, setImage, setImage, setIsGroup, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setPadding, setPageLeft, setPageTop, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setSkinImgDir, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTooltip, setTop, setTop, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getElement, getElement, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setElement, setHtmlElement, setID, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### Window

          public Window()

    - #### Window

          public Window(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static Window getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `VLayout`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `VLayout`

    - #### setAnimateMinimize

          public void setAnimateMinimize(java.lang.Boolean animateMinimize)

      Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?

      Note : This is an advanced setting

      Parameters:
        `animateMinimize` - animateMinimize Default value is null
      See Also:
        `Appearance overview and related methods`, Window Minimize Example

    - #### getAnimateMinimize

          public java.lang.Boolean getAnimateMinimize()

      Should this window minimize, maximize, and restore as an animation, or as a simple 1-step transition?
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`, Window Minimize Example

    - #### setAutoCenter

          public void setAutoCenter(java.lang.Boolean autoCenter)

      If true, this Window widget will automatically be centered on the page when shown. If false, it will show up in the last position it was placed (either programmatically, or by user interaction).
      Parameters:
        `autoCenter` - autoCenter Default value is autoCenter
      See Also:
        `Appearance overview and related methods`

    - #### getAutoCenter

          public java.lang.Boolean getAutoCenter()

      If true, this Window widget will automatically be centered on the page when shown. If false, it will show up in the last position it was placed (either programmatically, or by user interaction).
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setAutoSize

          public void setAutoSize(java.lang.Boolean autoSize)

      If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
      If this method is called after the component has been drawn/initialized: Setter for `autoSize`
      Parameters:
        `autoSize` - true if the window should auto-size to its content. Default value is false
      See Also:
        `Appearance overview and related methods`, Auto Size Example

    - #### getAutoSize

          public java.lang.Boolean getAutoSize()

      If true, the window is resized automatically to accommodate the contents of the body, if they would otherwise require scrolling.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`, Auto Size Example

    - #### getBody

          public Canvas getBody()
                         throws java.lang.IllegalStateException

      Body of the Window, where `contained components` or `loaded content` is shown.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setBodyColor

          public void setBodyColor(java.lang.String bodyColor)

      Color of the Window body. Overrides the background color specified in the style.
      Parameters:
        `bodyColor` - . See `String`. Default value is "#FFFFFF"
      See Also:
        `flash()`, `Appearance overview and related methods`

    - #### getBodyColor

          public java.lang.String getBodyColor()

      Color of the Window body. Overrides the background color specified in the style.
      Returns:
        . See `String`
      See Also:
        `flash()`, `Appearance overview and related methods`

    - #### setBodyStyle

          public void setBodyStyle(java.lang.String bodyStyle)

      Style of the Window body.
      Parameters:
        `bodyStyle` - . See `String`. Default value is "windowBody"
      See Also:
        `Appearance overview and related methods`

    - #### getBodyStyle

          public java.lang.String getBodyStyle()

      Style of the Window body.
      Returns:
        . See `String`
      See Also:
        `Appearance overview and related methods`

    - #### setCanDragReposition

          public void setCanDragReposition(java.lang.Boolean canDragReposition)

      If true, this Window may be moved around by the user by dragging on the Window header. Note that if the header is not showing, the Window can't be drag-repositioned regardless of this setting.
      Overrides:
        `setCanDragReposition` in class `Canvas`
      Parameters:
        `canDragReposition` - canDragReposition Default value is true
      See Also:
        `setShowHeader(java.lang.Boolean)`

    - #### getCanDragReposition

          public java.lang.Boolean getCanDragReposition()

      If true, this Window may be moved around by the user by dragging on the Window header. Note that if the header is not showing, the Window can't be drag-repositioned regardless of this setting.
      Overrides:
        `getCanDragReposition` in class `Canvas`
      Returns:
        Boolean
      See Also:
        `getShowHeader()`

    - #### setCanDragResize

          public void setCanDragResize(java.lang.Boolean canDragResize)

      Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
      Overrides:
        `setCanDragResize` in class `Canvas`
      Parameters:
        `canDragResize` - canDragResize Default value is false
      See Also:
        `setShowResizer(java.lang.Boolean)`

    - #### getCanDragResize

          public java.lang.Boolean getCanDragResize()

      Can the window be drag-resized? If true the window may be drag resized from its edges, and if showing, via the resizer icon in the footer.
      Overrides:
        `getCanDragResize` in class `Canvas`
      Returns:
        Boolean
      See Also:
        `getShowResizer()`

    - #### setCanFocusInHeaderButtons

          public void setCanFocusInHeaderButtons(java.lang.Boolean canFocusInHeaderButtons)

      If true, the user can give the header buttons keyboard focus (by clicking on them and including them in the tabOrder)

      Note : This is an advanced setting

      Parameters:
        `canFocusInHeaderButtons` - canFocusInHeaderButtons Default value is false
      See Also:
        `Focus overview and related methods`

    - #### getCanFocusInHeaderButtons

          public java.lang.Boolean getCanFocusInHeaderButtons()

      If true, the user can give the header buttons keyboard focus (by clicking on them and including them in the tabOrder)
      Returns:
        Boolean
      See Also:
        `Focus overview and related methods`

    - #### getCloseButton

          public ImgButton getCloseButton()
                                   throws java.lang.IllegalStateException

      Button show in the header that will close this Window by calling `Window.closeClick`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ImgButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setContentLayout

          public void setContentLayout(java.lang.String contentLayout)

      The layout policy that should be used for widgets within the Window body.

      Valid values are "vertical", "horizontal", "none". If the body is a Layout, this controls how the items are stacked in the body by setting `vertical`. See `bodyConstructor` for details.

      Note : This is an advanced setting

      Parameters:
        `contentLayout` - . See `String`. Default value is "vertical"
      See Also:
        `Appearance overview and related methods`

    - #### getContentLayout

          public java.lang.String getContentLayout()

      The layout policy that should be used for widgets within the Window body.

      Valid values are "vertical", "horizontal", "none". If the body is a Layout, this controls how the items are stacked in the body by setting `vertical`. See `bodyConstructor` for details.

      Returns:
        . See `String`
      See Also:
        `Appearance overview and related methods`

    - #### setContentsType

          public void setContentsType(java.lang.String contentsType)
                               throws java.lang.IllegalStateException

      If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.

      This is similar to the `contentsType` property - be sure to read the HTMLFlow documentation to understand circumstances where contentsType:"page" is unsafe and not recommended.

      Parameters:
        `contentsType` - . See `String`. Default value is "page"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setSrc(java.lang.String)`, `Appearance overview and related methods`

    - #### getContentsType

          public java.lang.String getContentsType()

      If this window has `src` specified, this property can be used to indicate whether the source is a standalone HTML page or an HTML fragment.

      This is similar to the `contentsType` property - be sure to read the HTMLFlow documentation to understand circumstances where contentsType:"page" is unsafe and not recommended.

      Returns:
        . See `String`
      See Also:
        `getSrc()`, `Appearance overview and related methods`

    - #### setDefaultMinimizeHeight

          public void setDefaultMinimizeHeight(int defaultMinimizeHeight)

      If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
      If there is no header, the `defaultMinimizeHeight` will be used instead.

      Note : This is an advanced setting

      Parameters:
        `defaultMinimizeHeight` - defaultMinimizeHeight Default value is 16
      See Also:
        `Appearance overview and related methods`

    - #### getDefaultMinimizeHeight

          public int getDefaultMinimizeHeight()

      If `minimizeHeight` is unset, by the window will shrink to the height of the header when minimized.
      If there is no header, the `defaultMinimizeHeight` will be used instead.
      Returns:
        int
      See Also:
        `Appearance overview and related methods`

    - #### setDismissOnEscape

          public void setDismissOnEscape(java.lang.Boolean dismissOnEscape)

      Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key? Behavior will only occur while the window or one of its descendants has focus, and does not cancel the Escape keypress.

      If unset default behavior depends on whether a close / cancel button is visible for this item.

      Parameters:
        `dismissOnEscape` - dismissOnEscape Default value is null
      See Also:
        `shouldDismissOnEscape()`

    - #### getDismissOnEscape

          public java.lang.Boolean getDismissOnEscape()

      Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key? Behavior will only occur while the window or one of its descendants has focus, and does not cancel the Escape keypress.

      If unset default behavior depends on whether a close / cancel button is visible for this item.

      Returns:
        Boolean
      See Also:
        `shouldDismissOnEscape()`

    - #### setDismissOnOutsideClick

          public void setDismissOnOutsideClick(java.lang.Boolean dismissOnOutsideClick)

      If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button.
      Note: Applies only to modal windows.
      Parameters:
        `dismissOnOutsideClick` - dismissOnOutsideClick Default value is false
      See Also:
        `setIsModal(java.lang.Boolean)`

    - #### getDismissOnOutsideClick

          public java.lang.Boolean getDismissOnOutsideClick()

      If true, a click outside the bounds of the Window will have the same effect as pressing its cancel button.
      Note: Applies only to modal windows.
      Returns:
        Boolean
      See Also:
        `getIsModal()`

    - #### getFooter

          public HLayout getFooter()
                            throws java.lang.IllegalStateException

      Optional footer for the window, providing space for controls such as the resizer and status bar.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        HLayout
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setFooterHeight

          public void setFooterHeight(int footerHeight)
                               throws java.lang.IllegalStateException

      The height of the footer, in pixels.
      Parameters:
        `footerHeight` - footerHeight Default value is 18
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getFooterHeight

          public int getFooterHeight()

      The height of the footer, in pixels.
      Returns:
        int
      See Also:
        `Appearance overview and related methods`

    - #### getHeader

          public HLayout getHeader()
                            throws java.lang.IllegalStateException

      Header for the Window, based on an HLayout. The header contains the title and some standard controls for the window, which may be configured via `headerControls`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        HLayout
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getHeaderBackground

          public Img getHeaderBackground()
                                  throws java.lang.IllegalStateException

      Img background component for the header, for gradient or image-based display

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Img
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getHeaderIcon

          public Img getHeaderIcon()
                            throws java.lang.IllegalStateException

      Header icon shown at left end of header by default.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Img
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getHeaderLabel

          public Label getHeaderLabel()
                               throws java.lang.IllegalStateException

      Label that shows Window title in header.

      The following `passthrough` applies: `title` for `contents`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Label
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setHeaderSrc

          public void setHeaderSrc(java.lang.String headerSrc)

      If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.

      Note : This is an advanced setting

      Parameters:
        `headerSrc` - . See `SCImgURL`. Default value is "[SKIN]Window/headerGradient.gif" | null
      See Also:
        `Appearance overview and related methods`

    - #### getHeaderSrc

          public java.lang.String getHeaderSrc()

      If `showHeaderBackground` is `true`, this property provides the URL of the background image for the header.
      Returns:
        . See `SCImgURL`
      See Also:
        `Appearance overview and related methods`

    - #### setHeaderStyle

          public void setHeaderStyle(java.lang.String headerStyle)

      Style for the Window header.

      Note : This is an advanced setting

      Parameters:
        `headerStyle` - . See `CSSStyleName`. Default value is "WindowHeader"
      See Also:
        `Appearance overview and related methods`

    - #### getHeaderStyle

          public java.lang.String getHeaderStyle()

      Style for the Window header.
      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setHiliteBodyColor

          public void setHiliteBodyColor(java.lang.String hiliteBodyColor)

      Highlight color for the Window body (shown when the body is flashed).
      Parameters:
        `hiliteBodyColor` - . See `String`. Default value is "#EEEEEE"
      See Also:
        `flash()`, `Appearance overview and related methods`

    - #### getHiliteBodyColor

          public java.lang.String getHiliteBodyColor()

      Highlight color for the Window body (shown when the body is flashed).
      Returns:
        . See `String`
      See Also:
        `flash()`, `Appearance overview and related methods`

    - #### setHiliteHeaderSrc

          public void setHiliteHeaderSrc(java.lang.String hiliteHeaderSrc)

      If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`

      Note : This is an advanced setting

      Parameters:
        `hiliteHeaderSrc` - . See `SCImgURL`. Default value is "[SKIN]Window/headerGradient_hilite.gif" | null
      See Also:
        `Appearance overview and related methods`

    - #### getHiliteHeaderSrc

          public java.lang.String getHiliteHeaderSrc()

      If `showHeaderBackground` is true, this governs the URL of the image to use in the header's highlighted state when the window is `flashed`
      Returns:
        . See `SCImgURL`
      See Also:
        `Appearance overview and related methods`

    - #### setHiliteHeaderStyle

          public void setHiliteHeaderStyle(java.lang.String hiliteHeaderStyle)

      Highlight style for the Window header. Displayed when a window is `flashed`

      Note : This is an advanced setting

      Parameters:
        `hiliteHeaderStyle` - . See `CSSStyleName`. Default value is "WindowHeader"
      See Also:
        `Appearance overview and related methods`

    - #### getHiliteHeaderStyle

          public java.lang.String getHiliteHeaderStyle()

      Highlight style for the Window header. Displayed when a window is `flashed`
      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setIsModal

          public void setIsModal(java.lang.Boolean isModal)

      If true, when shown this Window will intercept and block events to all other existing components on the page.

      Use `showModalMask` to darken all other elements on the screen when a modal dialog is showing.

      Chained modal windows - that is, modal windows that launch other modal windows - are allowed. You can accomplish this by simply creating a second modal Window while a modal Window is showing.

      Note only top-level Windows (Windows without parents) can be modal.

      Parameters:
        `isModal` - isModal Default value is false
      See Also:
        Modality Example

    - #### getIsModal

          public java.lang.Boolean getIsModal()

      If true, when shown this Window will intercept and block events to all other existing components on the page.

      Use `showModalMask` to darken all other elements on the screen when a modal dialog is showing.

      Chained modal windows - that is, modal windows that launch other modal windows - are allowed. You can accomplish this by simply creating a second modal Window while a modal Window is showing.

      Note only top-level Windows (Windows without parents) can be modal.

      Returns:
        Boolean
      See Also:
        Modality Example

    - #### getMaximizeButton

          public ImgButton getMaximizeButton()
                                      throws java.lang.IllegalStateException

      Button that will make this Window fill the browser via `Window.maximize`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ImgButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setMaximized

          public void setMaximized(java.lang.Boolean maximized)

      Is this window maximized. If true at init time, the window will be drawn maximized. To set this property at runtime use `Window.maximize` or `Window.restore`.
      Parameters:
        `maximized` - maximized Default value is false
      See Also:
        `Appearance overview and related methods`

    - #### getMaximized

          public java.lang.Boolean getMaximized()

      Is this window maximized. If true at init time, the window will be drawn maximized. To set this property at runtime use `Window.maximize` or `Window.restore`.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setMinimizeAcceleration

          public void setMinimizeAcceleration(AnimationAcceleration minimizeAcceleration)

      Default acceleration function for performing an animated minimize / maximize. If unset, `this.animateAcceleration` will be used by default instead

      Note : This is an advanced setting

      Parameters:
        `minimizeAcceleration` - minimizeAcceleration Default value is null
      See Also:
        `Appearance overview and related methods`

    - #### getMinimizeAcceleration

          public AnimationAcceleration getMinimizeAcceleration()

      Default acceleration function for performing an animated minimize / maximize. If unset, `this.animateAcceleration` will be used by default instead
      Returns:
        AnimationAcceleration
      See Also:
        `Appearance overview and related methods`

    - #### getMinimizeButton

          public ImgButton getMinimizeButton()
                                      throws java.lang.IllegalStateException

      ImgButton shown in the header that will minimize this Window by calling `Window.minimize`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ImgButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setMinimized

          public void setMinimized(java.lang.Boolean minimized)

      Is this window minimized. If true at init time, the window will be drawn minimized. To set this property at runtime use `Window.minimize` or `Window.restore`.
      Parameters:
        `minimized` - minimized Default value is false
      See Also:
        `Appearance overview and related methods`

    - #### getMinimized

          public java.lang.Boolean getMinimized()

      Is this window minimized. If true at init time, the window will be drawn minimized. To set this property at runtime use `Window.minimize` or `Window.restore`.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setMinimizeHeight

          public void setMinimizeHeight(java.lang.Integer minimizeHeight)

      Height for the window when minimized. If unset the window will shrink to the height of the header, if present, otherwise `this.defaultMinimizeHeight`

      Note : This is an advanced setting

      Parameters:
        `minimizeHeight` - minimizeHeight Default value is null
      See Also:
        `Appearance overview and related methods`

    - #### getMinimizeHeight

          public java.lang.Integer getMinimizeHeight()

      Height for the window when minimized. If unset the window will shrink to the height of the header, if present, otherwise `this.defaultMinimizeHeight`
      Returns:
        Integer
      See Also:
        `Appearance overview and related methods`

    - #### setMinimizeTime

          public void setMinimizeTime(java.lang.Integer minimizeTime)

      If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.

      Note : This is an advanced setting

      Parameters:
        `minimizeTime` - minimizeTime Default value is null
      See Also:
        `Appearance overview and related methods`, Window Minimize Example

    - #### getMinimizeTime

          public java.lang.Integer getMinimizeTime()

      If this window is minimizeable, and animateMinimize is true, what should the duration of the minimize / maximize be (in ms)? If unset defaults to `canvas.animationTime`.
      Returns:
        Integer
      See Also:
        `Appearance overview and related methods`, Window Minimize Example

    - #### getModalMask

          public Canvas getModalMask()
                              throws java.lang.IllegalStateException

      A ScreenSpan instance used to darken the rest of a page when a modal window is active. To use, set `showModalMask` to true, add a CSS style "modalMask" to the active skin (generally with background-color set), and adjust `modalMaskOpacity`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.
      See Also:
        `Appearance overview and related methods`

    - #### setModalMaskOpacity

          public void setModalMaskOpacity(int modalMaskOpacity)
                                   throws java.lang.IllegalStateException

      Controls the opacity of the modal mask displayed behind modal windows.
      Parameters:
        `modalMaskOpacity` - modalMaskOpacity Default value is 50
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.Window#setModalMask`, `Appearance overview and related methods`

    - #### getModalMaskOpacity

          public int getModalMaskOpacity()

      Controls the opacity of the modal mask displayed behind modal windows.
      Returns:
        int
      See Also:
        `getModalMask()`, `Appearance overview and related methods`

    - #### setModalMaskStyle

          public void setModalMaskStyle(java.lang.String modalMaskStyle)
                                 throws java.lang.IllegalStateException

      Specifies the CSS style for the modal mask.
      Parameters:
        `modalMaskStyle` - . See `String`. Default value is "modalMask"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.Window#setModalMask`, `Appearance overview and related methods`

    - #### getModalMaskStyle

          public java.lang.String getModalMaskStyle()

      Specifies the CSS style for the modal mask.
      Returns:
        . See `String`
      See Also:
        `getModalMask()`, `Appearance overview and related methods`

    - #### setOpacity

          public void setOpacity(java.lang.Integer opacity)

      Renders the widget to be partly transparent. A widget's opacity property may be set to any number between 0 (transparent) to 100 (opaque). Null means don't specify opacity directly, 100 is fully opaque. Note that heavy use of opacity may have a performance impact on some older browsers.

      In older versions of Internet Explorer (Pre IE9 / HTML5), opacity is achieved through proprietary filters. If `filters have been disabled` within this application developers must set `useOpacityFilter` to true for specific components on which opacity support is required.

      Also note that opacity is incompatible with `backMasks`, and that this property is enabled by default for Window instances.

      Note : This is an advanced setting

      Overrides:
        `setOpacity` in class `Canvas`
      Parameters:
        `opacity` - opacity Default value is null
      See Also:
        `Cues overview and related methods`

    - #### getOpacity

          public java.lang.Integer getOpacity()

      Renders the widget to be partly transparent. A widget's opacity property may be set to any number between 0 (transparent) to 100 (opaque). Null means don't specify opacity directly, 100 is fully opaque. Note that heavy use of opacity may have a performance impact on some older browsers.

      In older versions of Internet Explorer (Pre IE9 / HTML5), opacity is achieved through proprietary filters. If `filters have been disabled` within this application developers must set `useOpacityFilter` to true for specific components on which opacity support is required.

      Also note that opacity is incompatible with `backMasks`, and that this property is enabled by default for Window instances.

      Overrides:
        `getOpacity` in class `Canvas`
      Returns:
        Integer
      See Also:
        `Cues overview and related methods`

    - #### getResizer

          public ImgButton getResizer()
                               throws java.lang.IllegalStateException

      ImgButton-based resizer, shown in the footer.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ImgButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getRestoreButton

          public ImgButton getRestoreButton()
                                     throws java.lang.IllegalStateException

      ImgButton that restores the Window via `Window.restore`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ImgButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setShowBody

          public void setShowBody(java.lang.Boolean showBody)

      If true, draw the body contents when this Window is drawn.

      Note : This is an advanced setting

      Parameters:
        `showBody` - showBody Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowBody

          public java.lang.Boolean getShowBody()

      If true, draw the body contents when this Window is drawn.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowCloseButton

          public void setShowCloseButton(java.lang.Boolean showCloseButton)

      If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick`.
      If this method is called after the component has been drawn/initialized: Dynamically update `showCloseButton` to show / hide the closeButton
      Parameters:
        `showCloseButton` - showCloseButton Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowCloseButton

          public java.lang.Boolean getShowCloseButton()

      If true, show a close button in the header, which will dismiss this window by calling `Window.closeClick`.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowFooter

          public void setShowFooter(java.lang.Boolean showFooter)

      If true, show a footer for this Window, including resizer, statusBar, etc. This setting is commonly overridden for skinning purposes.
      Parameters:
        `showFooter` - showFooter Default value is true
      See Also:
        `Appearance overview and related methods`, Footer Example

    - #### getShowFooter

          public java.lang.Boolean getShowFooter()

      If true, show a footer for this Window, including resizer, statusBar, etc. This setting is commonly overridden for skinning purposes.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`, Footer Example

    - #### setShowHeader

          public void setShowHeader(java.lang.Boolean showHeader)
                             throws java.lang.IllegalStateException

      If true, show a `header` for this Window.

      Note that in certain Smartclient skins `showHeaderBackground` may be set to `false` and the header's appearance implemented as part of the window's `edge media`. In this case suppressing the header can be achieved by overriding the edge media as well as setting this property to false. For example, to create a headerless window with a similar appearance to a `Menu` in the `TreeFrog` skin, the following attributes could be used:

                 showHeader:false,
                 edgeImage:"[SKIN]/Menu/m.png",
                 edgeSize:10, edgeTop:17, edgeBottom:17,
                 edgeCenterBackgroundColor:"#F7F7F7"

      Note : This is an advanced setting

      Parameters:
        `showHeader` - showHeader Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getShowHeader

          public java.lang.Boolean getShowHeader()

      If true, show a `header` for this Window.

      Note that in certain Smartclient skins `showHeaderBackground` may be set to `false` and the header's appearance implemented as part of the window's `edge media`. In this case suppressing the header can be achieved by overriding the edge media as well as setting this property to false. For example, to create a headerless window with a similar appearance to a `Menu` in the `TreeFrog` skin, the following attributes could be used:

                 showHeader:false,
                 edgeImage:"[SKIN]/Menu/m.png",
                 edgeSize:10, edgeTop:17, edgeBottom:17,
                 edgeCenterBackgroundColor:"#F7F7F7"

      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowHeaderBackground

          public void setShowHeaderBackground(java.lang.Boolean showHeaderBackground)
                                       throws java.lang.IllegalStateException

      Should the window header show a background image? Default value is true for all browsers except for Internet Explorer.
      If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.

      Note : This is an advanced setting

      Parameters:
        `showHeaderBackground` - showHeaderBackground Default value is varies
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getShowHeaderBackground

          public java.lang.Boolean getShowHeaderBackground()

      Should the window header show a background image? Default value is true for all browsers except for Internet Explorer.
      If set to true the image source is derived from `headerSrc` and `hiliteHeaderSrc`, otherwise the background will be styled according to `headerStyle` / `hiliteHeaderStyle`.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowHeaderIcon

          public void setShowHeaderIcon(java.lang.Boolean showHeaderIcon)

      If true, we show an icon on the left in the header.
      If this method is called after the component has been drawn/initialized: Dynamically update `showHeaderIcon` to show / hide the headerIcon
      Parameters:
        `showHeaderIcon` - showHeaderIcon Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowHeaderIcon

          public java.lang.Boolean getShowHeaderIcon()

      If true, we show an icon on the left in the header.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowMaximizeButton

          public void setShowMaximizeButton(java.lang.Boolean showMaximizeButton)

      If true, show a maximize button in the header - clicking it maximizes the Window
      If this method is called after the component has been drawn/initialized: Dynamically update `showMaximizeButton` to show / hide the maximizeButton
      Parameters:
        `showMaximizeButton` - showMaximizeButton Default value is false
      See Also:
        `Appearance overview and related methods`

    - #### getShowMaximizeButton

          public java.lang.Boolean getShowMaximizeButton()

      If true, show a maximize button in the header - clicking it maximizes the Window
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowMinimizeButton

          public void setShowMinimizeButton(java.lang.Boolean showMinimizeButton)

      If true, show a minimize button in the header--clicking it minimizes the Window.
      If this method is called after the component has been drawn/initialized: Dynamically update `showMinimizeButton` to show / hide the minimizeButton
      Parameters:
        `showMinimizeButton` - showMinimizeButton Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowMinimizeButton

          public java.lang.Boolean getShowMinimizeButton()

      If true, show a minimize button in the header--clicking it minimizes the Window.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowModalMask

          public void setShowModalMask(java.lang.Boolean showModalMask)
                                throws java.lang.IllegalStateException

      If true, displays a translucent mask over the rest of the page when a modal window is displayed.
      Parameters:
        `showModalMask` - showModalMask Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.Window#setModalMask`, `Appearance overview and related methods`

    - #### getShowModalMask

          public java.lang.Boolean getShowModalMask()

      If true, displays a translucent mask over the rest of the page when a modal window is displayed.
      Returns:
        Boolean
      See Also:
        `getModalMask()`, `Appearance overview and related methods`

    - #### setShowResizer

          public void setShowResizer(java.lang.Boolean showResizer)

      If true, show a button in the lower right corner that allows users to resize the Window. Note that the resizer will only be displayed if the footer is showing for the window (`showFooter`) and `canDragResize` is true.
      Parameters:
        `showResizer` - showResizer Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowResizer

          public java.lang.Boolean getShowResizer()

      If true, show a button in the lower right corner that allows users to resize the Window. Note that the resizer will only be displayed if the footer is showing for the window (`showFooter`) and `canDragResize` is true.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowStatusBar

          public void setShowStatusBar(java.lang.Boolean showStatusBar)

      If true, show a statusBar for this Window, including resizer.
      Parameters:
        `showStatusBar` - showStatusBar Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowStatusBar

          public java.lang.Boolean getShowStatusBar()

      If true, show a statusBar for this Window, including resizer.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setShowTitle

          public void setShowTitle(java.lang.Boolean showTitle)

      Show a title (typically just text) on the header for this window.
      Parameters:
        `showTitle` - showTitle Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getShowTitle

          public java.lang.Boolean getShowTitle()

      Show a title (typically just text) on the header for this window.
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setSrc

          public void setSrc(java.lang.String src)

      A URL to load as content for the Window's body. If specified, this attribute will take precedence over the items attribute.

      Note that setting window.src is essentially a shortcut for setting `items` to a single HTMLflow with a specified `contentsURL`.
      If this method is called after the component has been drawn/initialized: Sets the URL of the contents to display in the body of the window, redrawing if necessary.

      Parameters:
        `src` - URL of new contents to be displayed in the window body. See `String`. Default value is null
      See Also:
        `setContentsType(java.lang.String)`, `Appearance overview and related methods`

    - #### getSrc

          public java.lang.String getSrc()

      A URL to load as content for the Window's body. If specified, this attribute will take precedence over the items attribute.

      Note that setting window.src is essentially a shortcut for setting `items` to a single HTMLflow with a specified `contentsURL`.

      Returns:
        . See `String`
      See Also:
        `getContentsType()`, `Appearance overview and related methods`

    - #### setStatus

          public void setStatus(java.lang.String status)

      Text to show in the status bar of the window (if one is visible)
      If this method is called after the component has been drawn/initialized: Sets the text in the status bar of the window, redrawing if necessary.
      Parameters:
        `status` - new text for the status bar. See `String`. Default value is null
      See Also:
        `Appearance overview and related methods`

    - #### getStatus

          public java.lang.String getStatus()

      Text to show in the status bar of the window (if one is visible)
      Returns:
        . See `String`
      See Also:
        `Appearance overview and related methods`

    - #### getStatusBar

          public Canvas getStatusBar()
                              throws java.lang.IllegalStateException

      Simple Canvas-based status bar, shown in the footer. `Window.setStatus` can be used to show text here.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setTitle

          public void setTitle(java.lang.String title)

      title for this Window, shown in the header (if drawn)
      If this method is called after the component has been drawn/initialized: Sets the `title` that appears in the window `header`. The header will be redrawn if necessary.
      Overrides:
        `setTitle` in class `Canvas`
      Parameters:
        `title` - new title.. See `HTMLString`. Default value is "Untitled Window"
      See Also:
        `Appearance overview and related methods`

    - #### getTitle

          public java.lang.String getTitle()

      title for this Window, shown in the header (if drawn)
      Overrides:
        `getTitle` in class `Canvas`
      Returns:
        . See `HTMLString`
      See Also:
        `Appearance overview and related methods`

    - #### setUseBackMask

          public void setUseBackMask(java.lang.Boolean useBackMask)
                              throws java.lang.IllegalStateException

      By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9. This is a workaround for a native browser issue whereby certain DOM elements such as `IFRAME`s (whether rendered within Smart GWT components via features such as `contentsURL` or explicitly written into the HTML of the page) will not be properly occluded by DOM elements which overlap them but have a higher z-index.

      A side-effect of this is that the `opacity` can not be modified for the entire window. Developers may disable the backmask in order to support opacity in IE versions less than 9 by setting this property to false, however you should be aware that in doing this there is a potential for the "burn through" problem described above.

      Note : This is an advanced setting

      Overrides:
        `setUseBackMask` in class `Canvas`
      Parameters:
        `useBackMask` - useBackMask Default value is varies
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getUseBackMask

          public java.lang.Boolean getUseBackMask()

      By default Windows show a `backMask` in Internet Explorer versions predating Internet Explorer 9. This is a workaround for a native browser issue whereby certain DOM elements such as `IFRAME`s (whether rendered within Smart GWT components via features such as `contentsURL` or explicitly written into the HTML of the page) will not be properly occluded by DOM elements which overlap them but have a higher z-index.

      A side-effect of this is that the `opacity` can not be modified for the entire window. Developers may disable the backmask in order to support opacity in IE versions less than 9 by setting this property to false, however you should be aware that in doing this there is a potential for the "burn through" problem described above.

      Overrides:
        `getUseBackMask` in class `Canvas`
      Returns:
        Boolean

    - #### addMember

          public void addMember(Canvas newMember)

      Same as `Layout.addMember`. Note that in order to add items to `body`, you use `Window.addItem` rather than `addMember`. Adding a member to a Window adds the member as a sibling to the header, body and other built-in Window subcomponents.
      Overrides:
        `addMember` in class `Layout`
      Parameters:
        `newMember` - the canvas object to be added to the layout
      See Also:
        `Layout.addMembers(java.lang.Object[], int)`

    - #### addMember

          public void addMember(Canvas newMember,
                       java.lang.Integer position)

      Same as `Layout.addMember`. Note that in order to add items to `body`, you use `Window.addItem` rather than `addMember`. Adding a member to a Window adds the member as a sibling to the header, body and other built-in Window subcomponents.
      Parameters:
        `newMember` - the canvas object to be added to the layout
        `position` - the position in the layout to place newMember (starts with 0); if omitted, it will be added at the last position
      See Also:
        `Layout.addMembers(java.lang.Object[], int)`

    - #### centerInPage

          public void centerInPage()

      Centers the Window in the page. This is called automatically in window.show() if Window.autoCenter is true. Note - if the Window is a child of another widget, we center in the parent widget rather than centering in the page.
      See Also:
        `getAutoCenter()`, `Appearance overview and related methods`

    - #### close

          public void close()

      Close this window. This method is fired by the default `Window.closeClick` implementation. Default implementation will hide the window.

    - #### addCloseClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addCloseClickHandler(CloseClickHandler handler)

      Add a closeClick handler.

      Handles a click on the close button of this window. The default implementation calls `Window.close` and returns false to prevent bubbling of the click event.

      Developers may use `addCloseClickHandler()` to provide custom handling when the user clicks this button. Custom implementations may call `close()` to trigger the default behavior.

      Specified by:
        `addCloseClickHandler` in interface `HasCloseClickHandlers`
      Parameters:
        `handler` - the closeClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### flash

          public void flash()

      Makes the window header flash if it's visible; if there's no header, or the header is hidden, makes the window body flash instead.

      This method is executed when users click outside the bounds of a modal window so they'll notice that they have to do something with the window.

    - #### maximize

          public void maximize()

      Maximize the window. Fired when the user clicks the maximize button if `this.showMaximizeButton` is true.
      Default implementation moves the window to `0, 0` and resizes the window to `"100%"` on both axes, so it will fill the browser window (or the parentElement of the Window instance, if appropriate).
      If `animateMinimize` is true, the maximize will be animated. A restore button will be displayed in place of the maximize button when the window is maximized.

    - #### minimize

          public void minimize()

      Minimize the window. Fired when the user clicks the minimize button if `this.showMinimizeButton` is true.
      Default implementation shrinks the window to just the height of the header bar, hiding the body. If `animateMinimize` is true, the resize will be animated. A restore button will be displayed in place of the minimize button when the window is minimized.

    - #### onCloseClick

          public java.lang.Boolean onCloseClick()

      Notification method fired when the user attempts to close the window via a click on the 'close' button, click outside the window if `dismissOnOutsideClick` is true, or on escape keypress if `dismissOnEscape` is true.
      Returns:
        return false to cancel the default behavior (firing `Window.closeClick`)

    - #### addMaximizeClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addMaximizeClickHandler(MaximizeClickHandler handler)

      Add a maximizeClick handler.

      Notification method fired when the user clicks the 'maximize' button.

      Specified by:
        `addMaximizeClickHandler` in interface `HasMaximizeClickHandlers`
      Parameters:
        `handler` - the maximizeClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addMinimizeClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addMinimizeClickHandler(MinimizeClickHandler handler)

      Add a minimizeClick handler.

      Notification method fired when the user clicks the 'minimize' button.

      Specified by:
        `addMinimizeClickHandler` in interface `HasMinimizeClickHandlers`
      Parameters:
        `handler` - the minimizeClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addRestoreClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addRestoreClickHandler(RestoreClickHandler handler)

      Add a restoreClick handler.

      Notification method fired when the user clicks the 'restore' button.

      Specified by:
        `addRestoreClickHandler` in interface `HasRestoreClickHandlers`
      Parameters:
        `handler` - the restoreClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### restore

          public void restore()

      Restores the window to its specified height and width after a call to `Window.minimize` or `Window.maximize`. Called from a click on the restore button shown in place of the minimize or maximize button when the window is minimized or maximized.
      Resizing will occur as an animation if `animateMinimize` is true.

    - #### shouldDismissOnEscape

          public java.lang.Boolean shouldDismissOnEscape()

      Should this window be dismissed (same effect as pressing the "Cancel" button) when the user presses the "Escape" key?
      Default behavior: if `dismissOnEscape` is set, just return it. Otherwise return true if this window is showing a "close" control in the header (see `headerControls`).
      Returns:
        true if the window should be dismissed when the user hits escape

    - #### setDefaultProperties

          public static void setDefaultProperties(Window windowProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `windowProperties` - properties that should be used as new defaults when instances of this class are created

    - #### addItem

          public void addItem(com.google.gwt.user.client.ui.Widget widget)

      Adds a widget to the window.
      Parameters:
        `widget` - the widget to be added

    - #### addItem

          public void addItem(Canvas component)

      Adds a widget to the window.
      Parameters:
        `component` - the widget to be added

    - #### removeItem

          public void removeItem(Canvas component)

      Removes a widget from the window.
      Parameters:
        `component` - the widget to be removed

    - #### setKeepInParentRect

          public void setKeepInParentRect(java.lang.Boolean keepInParentRect)

      If Window.canDragReposition or Window.canDragResize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)?

      Note: keepInParentRect affects only user drag interactions, not programmatic moves.
      Overrides:
        `setKeepInParentRect` in class `Canvas`
      Parameters:
        `keepInParentRect` - true to keepInParentRect
      See Also:
        `Dragdrop overview and related methods`, Drag create Example

    - #### setBodyDefaults

          public void setBodyDefaults(java.util.Map bodyDefaults)

      Default properties for the body of the Window

      Note : This is an advanced setting

      Parameters:
        `bodyDefaults` - bodyDefaults

    - #### setHeaderIconDefaults

          public void setHeaderIconDefaults(java.util.Map headerIconDefaults)

      This is an object literal property block specifying the various properties of the headerIcon - the icon that appears at the top left of the window and is by default the Isomorphic logo. Overrideable defaults are as follows:
      - width - default to `16` and specifies the width of the headerIcon.
      - height - default to `14` and specifies the height of the headerIcon.
      - src - defaults to `"[SKIN]/Window/minimize.gif"` and specifies the image for the headerIcon.

        Note : This is an advanced setting

      Parameters:
        `headerIconDefaults` - headerIconDefaults

    - #### setHeaderIconProperties

          public void setHeaderIconProperties(java.util.Map headerIconProperties)

    - #### setHeaderIcon

          public void setHeaderIcon(java.lang.String imgSrc)

      Sets the Window header icon.
      Parameters:
        `imgSrc` - the icon image source

    - #### setHeaderIcon

          public void setHeaderIcon(java.lang.String imgSrc,
                           int width,
                           int height)

      Sets the Window header icon.
      Parameters:
        `imgSrc` - the icon image source
        `width` - the icon width. default 16
        `height` - the icon height. default 14

    - #### setHeaderControls

          public void setHeaderControls(java.lang.Object... headerControls)

      Array of members to show in the Window header. The default value of headerControls is an Array of `HeaderControls` listing the standard header controls in their default order:
      headerControls : [HeaderControls.HEADER_ICON, HeaderControls.HEADER_LABEL, HeaderControls.MINIMIZE_BUTTON, HeaderControls.MAXIMIZE_BUTTON, HeaderControls.CLOSE_BUTTON]

      You can set headerControls to change the order of standard controls in the header. You can also omit standard controls this way, although it more efficient to use the related "show" property if available (eg Window.showMinimizeButton).
      By embedding a Canvas directly in this list you can add arbitrary additional controls to the header, for example, an additional button (eg return to dock) or a DynamicForm with various kinds of input controls. Tip: custom controls need to set layoutAlign:"center" to appear vertically centered.
      Parameters:
        `headerControls` - an array containing either HeaderControl enums values or Canvas instances
      See Also:
        `HeaderControls`

    - #### setFooterControls

          public void setFooterControls(java.lang.Object... footerControls)

      Array of members to show in the Window footer. The default value of headerControls is an Array of `FooterControls` listing the standard footer controls in their default order:
      headerControls : [HeaderControls.SPACER, HeaderControls.RESIZER]

      You can set footerControls to change the order of standard controls in the footer. You can also omit standard controls this way, although it more efficient to use the related "show" property if available (eg Window.showResizer).
      By embedding a Canvas directly in this list you can add arbitrary additional controls to the footer.
      Note that the statusBar is not part of the set of footer controls - it is a separate canvas rendered behind all footer controls. If you include some custom status bar directly in the footerControls you may want to set +link{window.showFooter} to false. Tip: custom controls need to set layoutAlign:"center" to appear vertically centered.
      Parameters:
        `footerControls` - an array containing either FooterControl enums values or Canvas instances
      See Also:
        `FooterControls`

    - #### setKeepInParentRect

          public void setKeepInParentRect(Rectangle rectangle)

      If Window.canDragReposition or Window.canDragRShowcaseDataesize is true, should the windows size and position be constrained such that it remains within the viewport of its parent element (or for top level windows, within the viewport of the browser window)? Can also be set to an array denoting an arbitrary Rectangle beyond which the window cannot be moved.
      Note: keepInParentRect affects only user drag interactions, not programmatic moves.
      Overrides:
        `setKeepInParentRect` in class `Canvas`
      Parameters:
        `rectangle` - the rectangle bounds

    - #### getItems

          public Canvas[] getItems()

      The contents of the Window body. Can be specified three different ways:
      - an Array of Canvases that will become the children of the Window's body when it is initialized; the canvases in this array should be created, but not drawn (autodraw: false).
      - a single canvas that will become a child of the Window body.
      - a string that will be set as the body's contents.
      Returns:
        items

    - #### preloadImages

          public static void preloadImages()

      Preload primary window skin images

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.WindowLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `VLayout`